Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection_MinMax.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection_MinMax.hlsl	(revision 2054)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection_MinMax.hlsl	(revision 2095)
@@ -11,8 +11,10 @@
 }
 
-#define MAX_LIN_ITERATIONCOUNT 30  //80
-#define MIN_LIN_ITERATIONCOUNT 25  //60
+#define MAX_LIN_ITERATIONCOUNT 80  //80
+#define MIN_LIN_ITERATIONCOUNT 60  //60
 #define SECANT_ITERATIONCOUNT 1
-#define MAX_RAY_DEPTH 2
+#define MAX_RAY_DEPTH 4
+
+//#define METHOD1
 
 void linearSearch(  float3 x, float3 R, float3 N, samplerCUBE mp,
@@ -24,4 +26,8 @@
                     out float ppp)
 {
+ float3 Ra = abs(R), xa = abs(x);
+ float xm =  max(max(xa.x,xa.y),xa.z);
+ float Rm = max(max(Ra.x,Ra.y),Ra.z);
+ float a = xm / Rm;
  
  int shootL = 0, shootP = 0;          
@@ -29,13 +35,13 @@
  
  float min = minMax.x;
- float max = minMax.y;
- 
- float minT = 0;
- float maxT = 0;
+ float maximum = minMax.y;
+ 
+ float minD = 0;
+ float maxD = 0;
  {
   	float a = dot(R,R);
 	float b = 2 * dot(R, x);
 	float c = dot(x,x) - min * min; 
-	float c2 = dot(x,x) - max * max; 
+	float c2 = dot(x,x) - maximum * maximum; 
 	
 	float dis = b*b - 4*a*c;
@@ -51,39 +57,58 @@
 	{
 	 numvalids++;
-	 if(t1 > maxT)maxT = t1;
-	 if(t1 < minT || minT == 0)minT = t1;
+	 if(t1 > maxD)maxD = t1;
+	 if(t1 < minD || minD == 0)minD = t1;
 	}
 	if(t2 > 0)
 	{
 	 numvalids++;
-	 if(t2 > maxT)maxT = t2;
-	 if(t2 < minT || minT == 0)minT = t2;
+	 if(t2 > maxD)maxD = t2;
+	 if(t2 < minD || minD == 0)minD = t2;
 	}
 	if(t3 > 0)
 	{
 	 numvalids++;
-	 if(t3 > maxT)maxT = t3;
-	 if(t3 < minT || minT == 0)minT = t3;
+	 if(t3 > maxD)maxD = t3;
+	 if(t3 < minD || minD == 0)minD = t3;
 	}
 	if(t4 > 0)
 	{
 	 numvalids++;
-	 if(t4 > maxT)maxT = t4;
-	 if(t4 < minT || minT == 0)minT = t4;
+	 if(t4 > maxD)maxD = t4;
+	 if(t4 < minD || minD == 0)minD = t4;
 	}
 	
 	if(numvalids % 2 == 1)
-	 minT = 0.01;
+	 minD = 0.01;
 	if(numvalids == 0)
-	 minT = maxT + 1.0;	
+	 minD = maxD + 1.0;	
  }
  
+#ifdef METHOD1
  int iterationNeeded = MAX_LIN_ITERATIONCOUNT;// + (dot(normalize(x), R) + 1.0) / 2.0 * (MAX_LIN_ITERATIONCOUNT - MIN_LIN_ITERATIONCOUNT);
  float pa;
- float dt = (maxT - minT) / (float) iterationNeeded ;
- dp = minT;
+ float dD = (maxD - minD) / (float) iterationNeeded ;
+ dp = minD; 
+ 
  //Linear iteration
- while(dp <= maxT && !found)
+ while(dp <= maxD && !found)
  {
+	 
+#else
+ float dt =  length(x / xm - R / Rm) * MAX_LIN_ITERATIONCOUNT;
+ dt = max(dt, MIN_LIN_ITERATIONCOUNT);
+ dt = 1.0 / dt;
+ 
+ float minT = max(minD / (a + minD) - dt, dt);
+ float maxT = maxD / (a + maxD) + dt;
+ 
+ float t = minT;//dt;
+ float pa;
+ 
+ while(t <= maxT && !found)
+ {
+	 dp = a * t / (1 - t);
+#endif
+
    p = x + R * dp;
    pa = readDistanceCubeMap(mp, p);
@@ -107,6 +132,10 @@
    else
      shootL = 0;
-      
-   dp += dt;  
+ 
+ #ifdef METHOD1     
+   dp += dD; 
+ #else 
+   t += dt;
+ #endif
  }
 
@@ -214,5 +243,5 @@
 							uniform float4 min1,
 							uniform float4 min2,
-							uniform float4 max,
+							uniform float4 Max,
 							uniform float4 max1,
 							uniform float4 max2) : COLOR0
@@ -220,5 +249,5 @@
 	float2 miniMaxi1;
     miniMaxi1.x = min.a;
-    miniMaxi1.y = max.a;
+    miniMaxi1.y = Max.a;
    
     float2 miniMaxi2;
@@ -258,9 +287,8 @@
 	   x = l;	   
 	   N = Nl;
-	   V = R;   
-	   
+	   V = R;   	   
 	}
 	if(I.a == 0)
-	   I = readCubeMap(CubeMap, l);
+	  I = readCubeMap(CubeMap, l);
 	
 	return I;
@@ -275,9 +303,9 @@
 							uniform float3 lastCenter,
 							uniform float refIndex,
-							//uniform float sFresnel, //0.04 
+							uniform float sFresnel, //0.04 
 							uniform float4 min,
 							uniform float4 min1,
 							uniform float4 min2,
-							uniform float4 max,
+							uniform float4 Max,
 							uniform float4 max1,
 							uniform float4 max2) : COLOR0
@@ -285,5 +313,5 @@
 	float2 miniMaxi1;
     miniMaxi1.x = min.a;
-    miniMaxi1.y = max.a;
+    miniMaxi1.y = Max.a;
    
     float2 miniMaxi2;
@@ -295,58 +323,20 @@
     miniMaxi3.y = max2.a;
 
-	 float4 I = float4(0,0,0,0);
+	float4 I = float4(0,0,0,0);
 			
 	 float3 N = normalize(IN.wNormal.xyz);
 	 float3 x = IN.wPos.xyz - lastCenter;
 	 float3 V  = (IN.wPos.xyz - cameraPos);
+	  V = normalize(V);
 	 
-	 float sFresnel = 0.04;
-	 float F = sFresnel + pow(1 - dot(N, -V), 5) * (1 - sFresnel);
-	 
-	 V = normalize(V);
-	 float3 l;
-	 float4 Irefl;
+	 float F;
 	 int depth = 0;
-	
-	 while(depth < MAX_RAY_DEPTH)
-	 {
-	    float3 R;  
-	   R = normalize(reflect( V, N));	  
-	  	
-	   float3 Nl;
-	   float4 Il;
-	   l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, miniMaxi1, miniMaxi2, miniMaxi3, Il, Nl);
-	   if(Il.a == 0)
-	   {
-		   depth += 1;		 
-	   }
-	   else
-	   {
-		   I = Il;
-		   depth = MAX_RAY_DEPTH;
-	   }
-	   x = l;	   
-	   N = Nl;
-	   V = R;   
-	   
-	}
-	if(I.a == 0)
-	   I = readCubeMap(CubeMap, l);
-	Irefl = I;
-	
-	{
-	float4 Irefr;
-	N = normalize(IN.wNormal.xyz);
-	x = IN.wPos.xyz - lastCenter;
-	V  = (IN.wPos.xyz - cameraPos);
-	V = normalize(V);
-	depth = 0;
+	F = sFresnel + pow(1 - dot(N, -V), 5) * (1 - sFresnel);	 
 	
 	while(depth < MAX_RAY_DEPTH)
 	{
 	  float3 R;  
-	  
-	  float ri = refIndex;
-	 
+	  	 
+	  float ri = refIndex;	 
 	  if(dot(V,N) > 0)
 	  {
@@ -355,11 +345,12 @@
 	  }
 	  R = refract( V, N, ri);
-	  if(dot(R,R) == 0) R = reflect( V, N); 
-					
+	  if(dot(R,R) == 0) R = reflect( V, N);
+	  					
 	  float3 Nl;
 	  float4 Il;
-	  l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, miniMaxi1, miniMaxi2, miniMaxi3, Il, Nl);
+	  float3 l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, miniMaxi1, miniMaxi2, miniMaxi3, Il, Nl);
 	  if(Il.a == 0)
 	  {
+		  //I = readCubeMap(CubeMap, l);
 		   depth += 1;		 
 	  }
@@ -372,13 +363,9 @@
 	  N = normalize(Nl);
 	  V = R;	   	   
-	}
-	
-	if(I.a == 0)
-	   I = readCubeMap(CubeMap, l);
-	Irefr = I;
+	}  
 	    
-	I = Irefl * F + (1.0 - F) * Irefr;
-    }
- 	return I;
+	I *= (1.0 - F);	
+    
+	return I;
 }
 
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material	(revision 2054)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material	(revision 2095)
@@ -191,9 +191,5 @@
 					set_light_view true
 					set_light_farplane true
-				}
-				RenderTechnique CausticReciever
-				{
-					max_caster_count	3
-				}	
+				}				
 			}
 			
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/colorcube.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/colorcube.material	(revision 2054)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/colorcube.material	(revision 2095)
@@ -5,5 +5,5 @@
 		pass
 		{
-			//lighting off
+			lighting off
 			IllumTechniques
 			{
@@ -13,19 +13,20 @@
 					max_caster_count	10					
 				}				
-				RenderTechnique DepthShadowReciever
-				{
-				   max_light_count 1
-				   vertex_program_name GameTools/ShadowMap/ShadowDistVS
-				   fragment_program_name GameTools/ShadowMap/ShadowDistPS
-				   set_light_view true
-				   set_light_farplane true
-				}
+				//RenderTechnique DepthShadowReciever
+				//{
+				//   max_light_count 1
+				//   vertex_program_name GameTools/ShadowMap/ShadowDistVS
+				//   fragment_program_name GameTools/ShadowMap/ShadowDistPS
+				//   set_light_view true
+				//   set_light_farplane true
+				//}
 			}
 
 			texture_unit
 			{
-				texture roomc.PNG
-				tex_coord_set 0
-				colour_op modulate
+				texture roomcdark.PNG
+				//texture object_SE_0_PHOTONMAP
+				//tex_coord_set 0
+				//colour_op modulate
 			}
 		}
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_DepthShadow.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_DepthShadow.hlsl	(revision 2054)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_DepthShadow.hlsl	(revision 2095)
@@ -129,5 +129,5 @@
 }
 
-/*
+
 float4 distShadowPS(VS_OUT_SHADOW IN,
 					uniform float4x4 lightViewProj,
@@ -174,6 +174,6 @@
 	
 	return shadow + (1 - shadow) * light;
-}*/
-
+}
+/*
 float4 distShadowPS(VS_OUT_SHADOW IN,
 					uniform float4x4 lightViewProj,
@@ -212,5 +212,5 @@
 	return shadow + (1 - shadow) * light;
 }
-
+*/
 /*
 float4 depthShadowPS(VS_OUT_SHADOW IN,
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 2057)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 2095)
@@ -36,8 +36,9 @@
 bool multiplebounce = true;
 
-int currentMaterial = 6;
-int currentObject = 0;
+int currentMaterial = 2;
+int currentObject = 2;
 String objectNames[] = {String("sphere.mesh"),
-                        String("teapot.mesh")};
+                        String("teapot.mesh"),
+						String("buddha.mesh")};
 
 String materialNames[] = {String("GTP/MultiBounce/Reflector"),
@@ -46,6 +47,5 @@
 							String("GTP/MultiBounce/Reflector_MinMax"),
 							String("GTP/MultiBounce/Refractor_MinMax"),
-							String("GTP/MultiBounce/CausticRefractor_MinMax"),
-							String("GTP/MultiBounce/Refractor2L")};
+							String("GTP/MultiBounce/CausticRefractor_MinMax")};
                         
 String resourceGroupName[] = {	String("GTP_MultipleReflection"),
@@ -54,6 +54,5 @@
 								String("GTP_MultipleReflection_MinMax"),
 								String("GTP_MultipleRefraction_MinMax"),
-								String("GTP_MultipleRefraction_MinMax"),
-								String("GTP_MultipleRefraction2L")};
+								String("GTP_MultipleRefraction_MinMax")};
 
 // Listener class for frame updates
@@ -106,25 +105,36 @@
 
 		if (mInputDevice->isKeyDown(KC_J))
-        {
-			MaterialPtr mat1 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/Refractor2L");
-			GpuProgramParameters* Fparams1 = mat1->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
-			MaterialPtr mat2 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/PhotonMap2L");
-			GpuProgramParameters* Fparams2 = mat2->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+        {			
+			refIndex -= 0.001;
+
+			MaterialPtr mat1 = MaterialManager::getSingleton().getByName(materialNames[currentMaterial]);
+			if(!mat1.isNull())
+			{
+			  GpuProgramParameters* Fparams1 = mat1->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			  Fparams1->setNamedConstant("refIndex", refIndex);
+			}
+			MaterialPtr mat2 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/PhotonMap");
+			if(!mat2.isNull())
+			{
+			  GpuProgramParameters* Fparams2 = mat2->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			  Fparams2->setNamedConstant("refIndex", refIndex);
+			}
+        }
+		if (mInputDevice->isKeyDown(KC_K))
+        {
+			refIndex += 0.001;
 			
-			refIndex -= 0.001;
-
-			Fparams1->setNamedConstant("refIndex", refIndex);
-			Fparams2->setNamedConstant("refIndex", refIndex);
-        }
-		if (mInputDevice->isKeyDown(KC_K))
-        {
-			MaterialPtr mat1 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/Refractor2L");
-			GpuProgramParameters* Fparams1 = mat1->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
-			MaterialPtr mat2 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/PhotonMap2L");
-			GpuProgramParameters* Fparams2 = mat2->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
-			
-			refIndex += 0.001;
-			Fparams1->setNamedConstant("refIndex", refIndex);
-			Fparams2->setNamedConstant("refIndex", refIndex);
+			MaterialPtr mat1 = MaterialManager::getSingleton().getByName(materialNames[currentMaterial]);
+			if(!mat1.isNull())
+			{
+			  GpuProgramParameters* Fparams1 = mat1->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			  Fparams1->setNamedConstant("refIndex", refIndex);
+			}
+			MaterialPtr mat2 = MaterialManager::getSingleton().getByName("GTP/MultiBounce/PhotonMap");
+			if(!mat2.isNull())
+			{
+			  GpuProgramParameters* Fparams2 = mat2->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			  Fparams2->setNamedConstant("refIndex", refIndex);
+			}
         }
 
@@ -220,21 +230,5 @@
 			capture->playEvent();
             mTimeUntilNextToggle = 1;
-        }
-		if (mInputDevice->isKeyDown(KC_V) && mTimeUntilNextToggle <= 0)
-        {
-			multiplebounce = ! multiplebounce;
-			if(multiplebounce)
-			{
-				MaterialPtr mat = MaterialManager::getSingleton().getByName("MetalTeapotMultipleBounce");
-				mat->getTechnique(0)->getPass(0)->getFragmentProgramParameters()->setNamedConstant("SingleBounce", 0.0f);
-			}
-			else
-			{
-				MaterialPtr mat = MaterialManager::getSingleton().getByName("MetalTeapotMultipleBounce");
-				mat->getTechnique(0)->getPass(0)->getFragmentProgramParameters()->setNamedConstant("SingleBounce", 1.0f);
-			}
-
-            mTimeUntilNextToggle = 1;
-        }
+        }	
 
         if( mInputDevice->isKeyDown( KC_ESCAPE) )
@@ -338,7 +332,7 @@
 		ResourceGroupManager::getSingleton().initialiseResourceGroup(resourceGroupName[currentMaterial]);
 		if(currentMaterial == 2)
-			ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultiBounce_PhotonMap");
+			ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultipleCausticRefraction");
 		if(currentMaterial == 5)
-			ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultiBounce_PhotonMap_MinMax");
+			ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_MultipleCausticRefraction_MinMax");
 	}
 
@@ -478,7 +472,7 @@
 		//mCamera->getParentSceneNode()->translate(Vector3(6.564,4.328,0.059));
 		//mCamera->setPosition(4.0,4.2,-3.5);
-		mCamera->getParentSceneNode()->translate(7.0,2.6,-0.5);
-		//mCamera->setPosition(7.0,2.6,-0.5);
-		//mCamera->lookAt(Vector3(1.0, 0.0,0.6));
+		//mCamera->getParentSceneNode()->translate(7.0,2.6,-0.5);
+		mCamera->setPosition(7.0,2.6,-0.5);
+		mCamera->lookAt(Vector3(1.0, 0.0,0.6));
 		Entity* object;
 		
@@ -520,10 +514,10 @@
 		Light1->setSpotlightRange(Degree(0),Degree(120));
 		LightNode1->attachObject(Light1);
-
+/*
 		BillboardSet* bbs = mSceneMgr->createBillboardSet("bb", 1);
 		bbs->setDefaultDimensions(0.2, 0.2);
 		bbs->createBillboard(Vector3::ZERO, ColourValue::White);
 		bbs->setMaterialName("Flare");
-		LightNode1->attachObject(bbs);
+		LightNode1->attachObject(bbs);*/
    }
 
Index: /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/resources.cfg
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/resources.cfg	(revision 2058)
+++ /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/resources.cfg	(revision 2095)
@@ -44,7 +44,14 @@
 [GTP_MultipleRefraction]
 FileSystem=../../Media/materials/GTPAdvancedEnvMap/multibounce/multipleRefraction
-[GTP_MultipleRefraction2L]
-FileSystem=../../Media/materials/GTPAdvancedEnvMap/multibounce/multipleRefraction2L
+
+[GTP_MultipleCausticRefraction]
+FileSystem=../../Media/materials/GTPAdvancedEnvMap/multibounce/multipleCausticRefraction
 
 [GTP_MultipleReflection_MinMax]
 FileSystem=../../Media/materials/GTPAdvancedEnvMap/multibounce/multipleReflectionMinMax
+
+[GTP_MultipleRefraction_MinMax]
+FileSystem=../../Media/materials/GTPAdvancedEnvMap/multibounce/multipleRefractionMinMax
+
+[GTP_MultipleCausticRefraction_MinMax]
+FileSystem=../../Media/materials/GTPAdvancedEnvMap/multibounce/multipleCausticRefractionMinMax
Index: /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 2058)
+++ /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 2095)
@@ -3,8 +3,8 @@
 [Direct3D9 Rendering Subsystem]
 Allow NVPerfHUD=No
-Anti aliasing=None
+Anti aliasing=Level 8
 Floating-point mode=Fastest
 Full Screen=No
-Rendering Device=NVIDIA GeForce 6800 GT
+Rendering Device=NVIDIA GeForce 8800 GTX
 VSync=No
 Video Mode=800 x 600 @ 32-bit colour
